#include <bios.h>
#include <alloc.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <time.h>
#include <dos.h>
#include "define.h"
#include "display.h"
#include "keyboard.h"
#include "symbol.h"
#include "console.h"
#include "switch.h"
#include "buffers.h"
#include "main.h"
#include "language.h"
#include "commands.h"
#include "message.h"
#include "autoproc.h"
#include "streams.h"
#include "params.h"
#include "script.h"
#include "node.h"
#include "config.h"
#include "protocol.h"
#include "argv.h"
#include "tools.h"
#include "protocol.h"
#include "users.h"
#include "database.h"
#include "ping.h"
#include "log.h"
#include "term.h"
#include "spy.h"

//------ Augmentation de la taille de la pile -------------------------------
#ifndef LINUX
//extern unsigned _stklen = 16384U;
extern unsigned _stklen = 8192U;
#endif

//------ Variables globales ------
int	MAIN_iMonitorOn	= TRUE;
time_t	MAIN_timeStart;
#ifndef LINUX
int	MAIN_bpqBuffLeft = 0;
#endif

extern int FirstStream;		//Dfinie dans SWITCH.CPP
extern int LastStream;		//Dfinie dans SWITCH.CPP

extern	unsigned long COMMANDS_statut[MAX_STREAMS];

extern char 	STREAMS_callsign[MAX_STREAMS][10];	//Dfinie dans STREAMS.CPP
extern char	STREAMS_level[MAX_STREAMS];		//idem

extern char	PROTOCOL_linkType[65];			//Dfinie dans PROTOCOL.CPP

extern	int	SCRIPT_fromStream[MAX_STREAMS];	//Y compris la console (F2)
extern	char	SCRIPT_fileName[65][9];		//Limit  8 caractres (+NULL), l'extension .FWD tant ajout chaque fois
extern	int	SCRIPT_timer[65];
extern	int	COMMANDS_iExitCode;
extern  int	STREAMS_iDiddle[MAX_STREAMS];
extern	int	PARAMS_iDefaultDiddle;
extern	int	MAIL_nTimeOut[MAX_STREAMS];
extern	unsigned long 	MAIL_lFwdMsgNumber[MAX_STREAMS];


//---------------------------------------------------------------------------
//------ Cette fonction est appelle avant de quitter DxNet -----------------
//---------------------------------------------------------------------------
void MAIN_ExitDxNet(void)
{
  //------ Librer la mmoire ------
  //ICI
  //ICI
  //------ Terminer le programme ------
  CON_restoreMode();	//Restaurer l'cran initial
  SWITCH_exitPcFlex();	//Quitter le kernel PcFlex
  printf("DxNet terminated normally.\n");
}

//---------------------------------------------------------------------------
//------ gestion des vnements CONSOLE (clavier) ---------------------------
//---------------------------------------------------------------------------
//Avant d'appeler cette fonction, il est ncessaire de s'assurer qu'une
//touche  bien t frappe -bioskey(1)-
void MAIN_console(void)
{
  static char 	SysopInputStr[80];
  static int  	SysopInputPos = 0;
  static char 	SwitchInputStr[80];
  static int  	SwitchInputPos = 0;
  int  		RetChar;

  DISP_PutStat();

  switch( DISP_GetActiveScreen() )
  {
	case SCREEN2 :
	  RetChar = ScanKeyboard(SysopInputStr, SysopInputPos, 79);
	  //Le sysop a-t-il valid la saisie ?
	  if( RetChar == CR )
	  {
	    //ajouter la commande dans le buffer d'entre
	    BUFFERS_printBuff(BUFFER_SCREEN2, IN, "%s\r", SysopInputStr);

	    //reinitialiser les variables
	    SysopInputStr[0] = SNULL;
	    SysopInputPos    = 0;
	  }
	  DISP_PutsInputString(SCREEN2, SysopInputStr, SysopInputPos);
	break;

	case SCREEN3 :
	  RetChar = ScanKeyboard(SwitchInputStr, SwitchInputPos, 79);
	  //Le sysop a-t-il valid la saisie ?
	  if( RetChar == CR )
	  {
	    //envoyer la ligne au module de gestion du terminal
#ifdef DOS
	    TERM_put(SwitchInputStr);
#endif
	    //reinitialiser les variables
	    SwitchInputStr[0] = SNULL;
	    SwitchInputPos    = 0;
	  }
	  DISP_PutsInputString(SCREEN3, SwitchInputStr, SwitchInputPos);

	break;

	default :
	  RetChar = getkey();
  }

  switch( RetChar )
  {
	case PGUPKEY :
	  DISP_StatRowUp();
	  break;

	case PGDNKEY :
	  DISP_StatRowDown();
	  break;

	case F1 :
	  DISP_SetActiveScreen( SCREEN1 );
	  break;

	case F2 :
	  DISP_SetActiveScreen( SCREEN2 );
	  break;

	case F3 :
	  DISP_SetActiveScreen( SCREEN3 );
	  break;

	case F4 :
	  DISP_SetActiveScreen( SCREEN4 );
	  break;
   }/* End SWITCH */
}

//--------------------------------------------------------------------------
//------ LOOP - L'ensemble du fonctionnement de DxNet se passe ICI ---------
//--------------------------------------------------------------------------
void MAIN_loop(void)
{
  static int 	StreamNum;
  static int   	index;
  static int 	job = TRUE;
  static char	Buffer[16384];

  static int	Secondes = -1,
		OldSecondes = -1;

  static int	iBuffSize;

  static char ConnectedCall[11];

#ifdef G3RTU
static int nTotalFC = 0;
#endif

  //------ Boucle Principale (rpte  l'infini) ------
  for(;;)
  {
    //Librer du temps machine sous LINUX
#ifdef LINUX
    if( ! job )
    {
	// Attendre un evenement
	while( SWITCH_wait(10) == 0 && OldSecondes == TOOLS_whatSec() );
    }
#endif
    job = FALSE;

    for(StreamNum = FirstStream; StreamNum <= LastStream; StreamNum++)
    {

      //------ Grer les vnements console ---------------------------------

      //Dtecter l'appuis sur une touche
      if( bioskey(1) )
      {
	MAIN_console();
	job = TRUE;
      }

      //Y a t-il une commande a xcuter pour la fentre PROGRAM (F1) ?
      if( BUFFERS_getRow(BUFFER_SCREEN1, Buffer, IN) )
      {
	CMD_execute(BUFFER_SCREEN1, Buffer);		//Executer la commande
#ifdef G3RTU
int nFC = fcloseall();
if( nFC )
{
	nTotalFC += nFC;
	LOG_write(LOG_BUFFERIN_FILE, LOG_DATE_NO, "[FC=%d] %d>%s\n", nTotalFC, StreamNum, Buffer);
}
#endif
	strcat(Buffer, "\n");				//Retour charriot
	if( Buffer[0] != 127 )	/* 127 : Id MACRO */
		DISP_PutsConsole(SCREEN1, Buffer, COLOR_IN);	//Afficher un echo de la commande sur l'cran
	job = TRUE;
      }

      //Y a t-il quelque chose  afficher dans la fentre PROGRAM (F1) ?
      if( BUFFERS_getBloc(BUFFER_SCREEN1, Buffer, OUT) )
      {
	DISP_PutsConsole(SCREEN1, Buffer, COLOR_OUT);
	job = TRUE;
      }

      //Y a t-il une commande a xcuter pour la fentre CONSOLE (F2) ?
      if( BUFFERS_getRow(BUFFER_SCREEN2, Buffer, IN) )
      {
	CMD_execute(BUFFER_SCREEN2, Buffer);		//Executer la commande
#ifdef G3RTU
int nFC = fcloseall();
if( nFC )
{
	nTotalFC += nFC;
	LOG_write(LOG_BUFFERIN_FILE, LOG_DATE_NO, "[FC=%d] %d>%s\n", nTotalFC, StreamNum, Buffer);
}
#endif
	strcat(Buffer, "\n");				//Retour charriot
	if( Buffer[0] != 127 )	/* 127 : Id MACRO */
		DISP_PutsConsole(SCREEN2, Buffer, COLOR_IN);	//Afficher un echo de la commande sur l'cran
	job = TRUE;
      }

      //Y a t-il quelque chose  afficher dans la fentre CONSOLE (F2) ?
      if( BUFFERS_getBloc(BUFFER_SCREEN2, Buffer, OUT) )
      {
	DISP_PutsConsole(SCREEN2, Buffer, COLOR_OUT);
	job = TRUE;
      }

      //------ Grer les vnements utilisateurs ----------------------------
      //------ Si le Stream est connect, traiter les buffers IN et OUT ----

      //Y a t-il des caractres en attente dans le SWITCH pour ce stream ?
      iBuffSize = SWITCH_getFrame(StreamNum, Buffer);
      if( iBuffSize )
      {
	//Peut-etre est-ce pour le terminal (version DOS uniquement)
#ifdef DOS
	if( StreamNum == TERM_conStream() )
	{
	  TOOLS_R2N(Buffer);
	  //Placer une SNULL a la fin de la chaine (car la fonction SWITCH
	  //ne le retourne pas
	  Buffer[iBuffSize] = SNULL;
	  DISP_PutsConsole(SCREEN3, Buffer, COLOR_OUT);
        }
	else
	  BUFFERS_addBuff_sized(StreamNum, Buffer, IN, iBuffSize);
#else
	BUFFERS_addBuff_sized(StreamNum, Buffer, IN, iBuffSize);
#endif
	job = TRUE;
      }

      //Y a t-il une commande  xcuter dans le stream ?
      if( BUFFERS_getRow(StreamNum, Buffer, IN) )
      {
	//------ Aiguillage ------
	if( STREAMS_level[StreamNum] & LEVEL_user )		//Utilisateur
	  CMD_execute(StreamNum, Buffer);
	else
	if( STREAMS_level[StreamNum] & LEVEL_linkSetup )	//Linl Setup
	  SCRIPT_do(StreamNum, Buffer);
	else      						//Cluster
	if( STREAMS_level[StreamNum] & LEVEL_cluster )
	{
	  //Si le protocol est un CluLink, ajouter un '\n'  la fin de la
	  //la chaine, car ce caractre n'est pas envoy  l'mission
	  PROTOCOL_do(StreamNum, Buffer);
	}
	job = TRUE;
#ifdef G3RTU
int nFC = fcloseall();
if( nFC )
{
	nTotalFC += nFC;
	LOG_write(LOG_BUFFERIN_FILE, LOG_DATE_NO, "[FC=%d] %d>%s\n", nTotalFC, StreamNum, Buffer);
}
#endif
      }

      //Y a t-il quelque chose en attente a envoyer au switch ?
#ifdef LINUX
      iBuffSize = BUFFERS_getBloc(StreamNum, Buffer, OUT);
#else
      if( SWITCH_getUnack(StreamNum) < 8 )
	iBuffSize = BUFFERS_getBloc(StreamNum, Buffer, OUT);
      else
	iBuffSize = 0;
#endif

      if( iBuffSize )
      {
	//Remplacer les '\n' par des '\r' sauf s'il s'agit d'une trame CluLink
	if( PROTOCOL_linkType[StreamNum] != CLU_LINK )
	  TOOLS_N2R(Buffer);

	SWITCH_sendFrame(StreamNum, Buffer, iBuffSize);

	//Initialiser la variable Diddle (sauf si c'est un cluster)
	if( ! (STREAMS_level[StreamNum] & LEVEL_cluster) )
	  STREAMS_iDiddle[StreamNum] = PARAMS_iDefaultDiddle;

	job = TRUE;
      }/*End IF*/

      //------ Nouvel vnement sur le Stream ? ------
      switch( SWITCH_getStatut(StreamNum) )
      {
	case NONE :
	  //Donc ne fait rien
	  break;

	case CONNECTED :
	  //Qui a connect le SWITCH ?
	  SWITCH_getCall(StreamNum, ConnectedCall);
	  STREAMS_connect(StreamNum, ConnectedCall);
	  job = TRUE;
	  break;

	case DISCONNECTED :
#ifdef DOS
	  if( StreamNum == TERM_conStream() )
	    TERM_disconnect();
	  else
	    STREAMS_disconnect(StreamNum);
#else
	  //Vrifier si un indicatif est connu
	  STREAMS_disconnect(StreamNum);
#endif
	  job = TRUE;
	  break;
      }

      //------ Afficher le monitoring ---------------------------------------
      if( MAIN_iMonitorOn && SWITCH_rawRx(1, Buffer) )
      {
#ifdef DOS
	/*Gestion des spy*/
	SPY_frame (Buffer);
#endif
	DISP_PutsConsole(MONITOR, Buffer, OUT);
	job = TRUE;
      }

      //------ Faut-il dconnecter le stream ? ------------------------------
      if( COMMANDS_statut[StreamNum] & COMMANDS_statutDisconnect )
      {
	//Dconnecter si toutes les trames en attente ont t ACK
	if( SWITCH_getUnack(StreamNum) == 0 )
	{
	  SWITCH_discSwitch( StreamNum );

	  //Pour que le stream puisse tre  nouveau connect ...
	  COMMANDS_statut[StreamNum] = COMMANDS_statutInit;
	  job = TRUE;
	}
      }/*End IF*/

      /* Faudra t-il deconnecter ce stream lors de la prochaine boucle ? */
      if( COMMANDS_statut[StreamNum] & COMMANDS_statutWillDisconnect )
      {
	COMMANDS_statut[StreamNum] &= ~COMMANDS_statutWillDisconnect;
	COMMANDS_statut[StreamNum] |= COMMANDS_statutDisconnect;
      }

      //------ ShutDown ? --------------------------------------------------
      if( COMMANDS_statut[0] & COMMANDS_statutShutDown )
      {
	int 	iCanDo = TRUE;

	//Ballayer les streams
	for(index = FirstStream; index <= LastStream; index++)
	{
	  //Le stream est-il tjrs connect ?
	  if( SWITCH_conStat(index) )
	    iCanDo = FALSE;
	}/*End FOR*/

	//Si un stream est tjrs connect, ne pas quitter
	if( iCanDo == TRUE )
	{
	  if( COMMANDS_iExitCode )
	    exit( COMMANDS_iExitCode );
	  else
	    exit(EXIT_SUCCESS);
	}
	job = TRUE;
      }/*End IF*/

      //------ Seconde ? ------
      Secondes = TOOLS_whatSec();

      //------ La seconde a t-elle change depuis la dernire fois ? --------
      if( Secondes != OldSecondes )
      {
#ifdef DOS
	if( Secondes == 0 && MAIN_bpqBuffLeft > 0 && ! SWITCH_isPcFlexNet())
	{
		if( SWITCH_getBufferLeft() < MAIN_bpqBuffLeft )
			exit(9);
	}
#endif
	//Afficher la barre de statut
	DISP_PutStat();

	//------ Lancement des process automatiques - Dclanchements aux ----
	//------ secondes rondes (ou  la prochaine seconde qui suit --------
	//------ un passage  zro en cas de dpassement) -------------------
	if( Secondes < OldSecondes )
	  AUTOPROC_do();

	//------ Timeout des scripts de connexion ---------------------------
	//------ Ainsi que le Diddle ----------------------------------------
	for(index = FirstStream; index <= LastStream; index++)
	{
	  if( STREAMS_level[index] & LEVEL_linkSetup )
	  {
	    if( --SCRIPT_timer[index] <= 0 )	//Timeout ?
	    {
	      BUFFERS_printBuff(SCRIPT_fromStream[index], OUT, "*** Link setup timeout with %s on stream %d.\n", SCRIPT_fileName[index], index);
	      MSG_send(SCRIPT_fromStream[index], MSG1);
	      SWITCH_discSwitch(index);
	      STREAMS_disconnect(index);
	    }/*End IF*/
	  }
	  else if( STREAMS_level[index] ) //Seulement s'il y a quelqu'un de connecte
	  {
	    if( (STREAMS_level[index] & LEVEL_cluster) &&
		MAIL_lFwdMsgNumber[index] && --MAIL_nTimeOut[index] <= 0 )
	    {
	      //Forward timeout
	      MAIL_lFwdMsgNumber[index] = 0L;
	      PROTOCOL_abortForwarding(index);
	    }

	    if( STREAMS_iDiddle[index] != -1 && STREAMS_level[index] != LEVEL_term )	//-1 signifie que la commande est sur off
	    {
	      if( --STREAMS_iDiddle[index] <= 0 )	//Faut-il envoyer un diddle packet ?
	      {
//		char	sBuffer[10];
//
//		sBuffer[0] = 32;
//		sBuffer[1] = 8;
//		sBuffer[2] = 0;

		//Oui, et il faut aussi reinitialiser la variable diddle
		if( STREAMS_level[index] & LEVEL_cluster )
		{
		  char sNodeCall[16];
		  /*Call du cluster */
		  NODE_getNodeCall(0, 0, sNodeCall);
		  PROTOCOL_userCount(index, sNodeCall, FALSE, 0, 100);
		  STREAMS_iDiddle[index] = 900;		/*15 minutes*/
		}
		else
		{
		  MSG_send(index, MSG41);	//transmettre le diddle
		  STREAMS_iDiddle[index] = PARAMS_iDefaultDiddle;
		}
	      }/*End IF*/
	    }/*End IF*/
	  }/*End IF*/
	}/*End FOR*/
	//Actualiser
	OldSecondes = Secondes;

#ifdef DEBUG_LOG_
	//Enregistrer l'heure (a la seconde pres) dans un fichier
	//Ceci permet, sous DOS, de connaitre l'heure d'un plantage
	LOG_saveTime();
#endif
      }/*End IF*/
    } /* End FOR */
  }/*End FOR*/
}

//--------------------------------------------------------------------------
//------ Fonction principale -----------------------------------------------
//--------------------------------------------------------------------------
int main(int Argc, char * Argv[])
{
  int 	_FirstStream 	= 1;
  int 	_LastStream 	= 64;
  int 	_ApplMask 	= 1;
  int 	iScreenSize;

  extern int PROTOCOL_nFixedInit;


  printf("DxNet started.\n");

  //------ Lecture des Arguments ------
  _FirstStream = ARGV_get(Argc, Argv, "-fs");
  if( _FirstStream == -1 )
    _FirstStream = 1;

  _LastStream = ARGV_get(Argc, Argv, "-ls");
  if( _LastStream == -1 )
    _LastStream = 64;

  _ApplMask = ARGV_get(Argc, Argv, "-appl");
  if( _ApplMask == -1 )
    _ApplMask = 1;

  iScreenSize = ARGV_get(Argc, Argv, "-s");
  if( iScreenSize != 43 && iScreenSize != 50 )
    iScreenSize = 25;

  if( ARGV_get(Argc, Argv, "-moff") != -1 )
    MAIN_iMonitorOn = FALSE;

  if( ARGV_get(Argc, Argv, "-noinit") != -1 )
    PROTOCOL_nFixedInit = FALSE;

#ifndef LINUX
  MAIN_bpqBuffLeft = ARGV_get(Argc, Argv, "-bpql");
#endif

  //------ Initialiser la table des streams ------
  BUFFERS_init();

  //------ Initialiser le SWITCH packet ------
  if( ! SWITCH_initSwitch(_FirstStream, _LastStream, _ApplMask) )
  {
    printf("*** Error : can't find either G8BPQ switch nor PcFlexNet kernel.\n");
    exit(EXIT_FAILURE);
  }

  //------ Initialiser la table des langues et des Helps ------
  LANG_init();

  //------ Initialiser les databases --------------------------
  DATABASE_init();

  printf("Starting DxNet...\n");
  delay(1000);

  //------ Initialiser les crans ------
  DISP_InitDisplay( iScreenSize );

  //------ Initialiser les paramtres du serveur ------
  if( ! USERS_init() )
  {
    printf("*** Error : not enough memory to allocate the users buffers.\n");
    exit(EXIT_FAILURE);
  }
  PARAMS_init();
  STREAMS_init();
  SCRIPT_init();
  NODE_init();
  COMMANDS_init();
  PING_init();
#ifndef LINUX
  TERM_init();
#endif

  //------ Heure du lancement de DxNet ------
  MAIN_timeStart = time(NULL);

  //------ Lire le fichier de configuration (SYSTEM\DXNET.CFG) ------
  CONFIG_init();
  
  /* Charger la config du cluster */
/*  USERS_openRecord(65, NODE_getNodeCall(0, 0, szCallSign));*/

  //------ Lancer DxNet ------
  atexit( MAIN_ExitDxNet );
  MAIN_loop();
  
  return 0;
}
